Bug 467407 - (mingw32-sqlite) Review Request: mingw32-sqlite - MinGW Windows port of sqlite embeddable SQL database engine
Review Request: mingw32-sqlite - MinGW Windows port of sqlite embeddable SQL ...
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Erik van Pienbroek
Fedora Extras Quality Assurance
:
Depends On: 454410 mingw32-pdcurses mingw32-readline
Blocks:
  Show dependency treegraph
 
Reported: 2008-10-17 07:08 EDT by Richard W.M. Jones
Modified: 2009-01-21 16:36 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-21 16:36:33 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
erik-fedora: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Richard W.M. Jones 2008-10-17 07:08:30 EDT
Spec URL: http://hg.et.redhat.com/misc/fedora-mingw--devel/?cmd=manifest;manifest=ea00554abe8421a9f5fb4506c9e6b35983a9005e;path=/sqlite/
SRPM URL: http://www.annexia.org/tmp/mingw/fedora-9/src/SRPMS/mingw32-sqlite-3.5.9-1.fc9.src.rpm
Description: MinGW Windows port of sqlite embeddable SQL database engine

Approved MinGW packaging guidelines are here:
http://fedoraproject.org/wiki/Packaging/MinGW
Comment 1 Erik van Pienbroek 2008-12-03 07:09:49 EST
Okay, here goes

$ rpmlint mingw32-sqlite.spec 
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint mingw32-sqlite-3.5.9-3.fc10.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

$ rpmlint mingw32-sqlite-3.5.9-3.fc10.noarch.rpm 
mingw32-sqlite.noarch: W: no-documentation
mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/lib/pkgconfig/sqlite3.pc
mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/include/sqlite3.h
mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/include/sqlite3ext.h
mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/lib/libsqlite3.dll.a
mingw32-sqlite.noarch: W: spurious-executable-perm /usr/i686-pc-mingw32/sys-root/mingw/lib/libsqlite3.dll.a
mingw32-sqlite.noarch: E: script-without-shebang /usr/i686-pc-mingw32/sys-root/mingw/lib/libsqlite3.la
mingw32-sqlite.noarch: E: arch-independent-package-contains-binary-or-object /usr/i686-pc-mingw32/sys-root/mingw/lib/libsqlite3.dll.a
mingw32-sqlite.noarch: W: non-standard-dir-in-usr i686-pc-mingw32
1 packages and 0 specfiles checked; 2 errors, 7 warnings.

$ rpmquery --requires mingw32-sqlite
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(CompressedFileNames) <= 3.0.4-1
mingw32-filesystem >= 39
mingw32-runtime  
mingw32(kernel32.dll)  
mingw32(libsqlite3-0.dll)  
mingw32(msvcrt.dll)  

$ md5sum sqlite-3.5.9.tar.gz 
b58412904b42fe49e5a281e99da0fd72  sqlite-3.5.9.tar.gz

$ curl http://sqlite.org/sqlite-3.5.9.tar.gz | md5sum
  % Total    % Received % Xferd  Average Speed   Time    Time     Time  Current
                                 Dload  Upload   Total   Spent    Left  Speed
100 2149k  100 2149k    0     0   692k      0  0:00:03  0:00:03 --:--:--  776k
b58412904b42fe49e5a281e99da0fd72  -

+ OK
- Needs to be looked into
/ Not applicable
? Unsure
* Overridden by MinGW guidelines

[+] Files are installed in /usr/i686-pc-mingw32/sys-root/mingw
[+] BuildRequires: mingw32-filesystem >= xx is in the .spec file
[+] Requires are OK
[+] BuildArch: noarch
[+] No man pages or info files
[+] No static libs
[+] default strip and objdump commands are overridden with mingw32 specific ones

[-] rpmlint must be run on every package. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption on Package Naming
Guidelines
[+] MUST: The package must meet the Packaging Guidelines
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[+] MUST: The License field in the package spec file must match the actual license.
[?] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL.
[+] MUST: The package must successfully compile and build into binary rpms on at least one supported architecture.
[/] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines; inclusion of those as BuildRequires is optional.
[/] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[/] MUST: Every binary RPM package which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
[/] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package.
[/] MUST: A package must own all directories that it creates. 
[+] MUST: A package must not contain any duplicate files in the %files listing.
[-] MUST: Permissions on files must be set properly.
[+] MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ).
[+] MUST: Each package must consistently use macros, as described in the macros section of Packaging Guidelines .
[+] MUST: The package must contain code, or permissable content.
[/] MUST: Large documentation files should go in a -doc subpackage.
[/] MUST: If a package includes something as %doc, it must not affect the runtime of the application.
[?] MUST: Header files must be in a -devel package.
[+] MUST: Static libraries must be in a -static package.
[-] MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
[/] MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in
a -devel package.
[/] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} =
%{version}-%{release}
[*] MUST: Packages must NOT contain any .la libtool archives, these should be removed in the spec.
[/] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with
desktop-file-install in the %install section.
[+] MUST: Packages must not own files or directories already owned by other packages.
[+] MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ). See Prepping BuildRoot For %install for
details.
[+] MUST: All filenames in rpm packages must be valid UTF-8.
[/] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[/] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock. See MockTricks for details on how to do this.
[/] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[+] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[/] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[?] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg.
[*] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.

---

Still to do:

rpmlint gives mostly false positives. There's one thing I think needs to be fixed:
W: spurious-executable-perm: /usr/i686-pc-mingw32/sys-root/mingw/lib/libsqlite3.dll.a

The MinGW Guidelines don't mention anything about -devel subpackage, so I don't know if these rpmlint messages can be ignored:
mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/lib/pkgconfig/sqlite3.pc
mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/include/sqlite3.h
mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/include/sqlite3ext.h
mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/lib/libsqlite3.dll.a

Finally, packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (according to the regular package guidelines)
Comment 2 Richard W.M. Jones 2008-12-09 17:29:42 EST
Thanks for taking a look at this.  I'm going to come back to this
when I've finished getting the base packages bootstrapped in F-10
and F-11 (https://fedorahosted.org/rel-eng/ticket/1103).

In the meantime, setting NEEDINFO of me.
Comment 3 Richard W.M. Jones 2008-12-16 11:03:54 EST
rpmlint isn't hugely useful for mingw packages at the moment.
Upstream rpmlint refused to make changes to accomodate the
packaging guidelines, but hopefully we can add some custom
rules at some point in the future.

The updated package here now has the following rpmlint
warnings:

mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/lib/pkgconfig/sqlite3.pc
mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/include/sqlite3.h
mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/include/sqlite3ext.h
mingw32-sqlite.noarch: W: devel-file-in-non-devel-package /usr/i686-pc-mingw32/sys-root/mingw/lib/libsqlite3.dll.a

These are fine.  All mingw packages are development
packages, so there is no -devel subpackage.

mingw32-sqlite.noarch: E: script-without-shebang /usr/i686-pc-mingw32/sys-root/mingw/lib/libsqlite3.la

Note that we currently include *.la files in mingw
packages, because libtool (probably) requires them
for linking.

mingw32-sqlite.noarch: E: arch-independent-package-contains-binary-or-object /usr/i686-pc-mingw32/sys-root/mingw/lib/libsqlite3.dll.a

This is OK because the file in question contains Windows
binary stubs - ie. arch-independent from the p.o.v. of
Fedora.

mingw32-sqlite.noarch: W: non-standard-dir-in-usr i686-pc-mingw32

And again, this is OK, mandated by GCC and the packaging
guidelines.

I've fixed the spurious executable permission, and added
'Requires: pkgconfig' which is needed.

Spec URL: http://www.annexia.org/tmp/mingw32-sqlite.spec
SRPM URL: http://www.annexia.org/tmp/mingw32-sqlite-3.6.6.2-1.fc10.src.rpm

* Tue Dec 16 2008 Richard Jones <rjones@redhat.com> - 3.6.6.2-1
- New upstream release (to match Fedora native), 3.6.6.2.
- Replace patches with ones from native.
- Rebase -no-undefined patch.
- Remove spurious +x permissions on libsqlite3.dll.a.
- Requires pkgconfig.
Comment 4 Erik van Pienbroek 2008-12-17 17:50:21 EST
Too bad upstream rpmlint refuses to accept patches for MinGW support. Maybe it is an idea to create a list of rpmlint failures which can be ignored for MinGW and put it on the MinGW guidelines page?

Anyway, this package looks good enough for inclusion in Fedora:

====================================================

 The package mingw32-sqlite is APPROVED by epienbro

====================================================
Comment 5 Richard W.M. Jones 2008-12-18 05:33:05 EST
Thanks for looking at this.

These are the bugs related to the rpmlint issue:
https://bugzilla.redhat.com/buglist.cgi?query_format=advanced&product=Fedora&component=rpmlint&long_desc_type=substring&long_desc=mingw&bug_status=NEW&bug_status=ASSIGNED&bug_status=MODIFIED&bug_status=ON_DEV&bug_status=ON_QA&bug_status=VERIFIED&bug_status=FAILS_QA&bug_status=RELEASE_PENDING&bug_status=POST&bug_status=CLOSED

We're waiting for rpmlint upstream to add a feature which
will allow us to mask off certain bugs for certain groups
of packages.
Comment 6 Richard W.M. Jones 2008-12-18 05:34:43 EST
New Package CVS Request
=======================
Package Name: mingw32-sqlite
Short Description: MinGW Windows port of sqlite embeddable SQL database engine
Owners: rjones berrange lfarkas
Branches: EL-5 F-10
InitialCC:
Comment 7 Kevin Fenzi 2008-12-20 23:06:39 EST
cvs done.
Comment 8 Richard W.M. Jones 2008-12-21 06:28:42 EST
Thanks Erik and Kevin for this.

I've done the import, but I won't be able to build it until
the two dependencies get imported.  So I'll leave this
bug open for the time being.
Comment 9 Fedora Update System 2009-01-21 05:53:29 EST
mingw32-sqlite-3.6.6.2-1.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/mingw32-sqlite-3.6.6.2-1.fc10
Comment 10 Fedora Update System 2009-01-21 16:36:29 EST
mingw32-sqlite-3.6.6.2-1.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.